%define python_sitearch %(python -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")
%define python_sitearch64 %(python_64 -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")

%define _libdir64 %{_prefix}/lib64

Name: rrdtool
Version: 1.2.30
Release: 3
Summary: Round Robin Database Tool to store and display time-series data
License: GPL
Group: Applications/Databases
URL: http://people.ee.ethz.ch/~oetiker/webtools/rrdtool/
Source: http://people.ee.ethz.ch/~oetiker/webtools/rrdtool/pub/rrdtool-%{version}.tar.gz
Patch0: %{name}-%{version}-%{release}-aix.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: freetype2-devel >= 2.3.12
BuildRequires: libart_lgpl-devel >= 2.3.20
BuildRequires: libpng-devel >= 1.2.44
BuildRequires: openssl-devel >= 0.9.8
BuildRequires: zlib-devel

Requires: freetype2 >= 2.3.12
Requires: libart_lgpl >= 2.3.20
Requires: libpng >= 1.2.44
Requires: zlib

%description
RRD is the Acronym for Round Robin Database. RRD is a system to store and 
display time-series data (i.e. network bandwidth, machine-room temperature, 
server load average). It stores the data in a very compact way that will not 
expand over time, and it presents useful graphs by processing the data to 
enforce a certain data density. It can be used either via simple wrapper 
scripts (from shell or Perl) or via frontends that poll network devices and 
put a friendly user interface on it.


%package devel
Summary: RRDtool static libraries and header files
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: freetype2-devel >= 2.3.12
Requires: libart_lgpl-devel >= 2.3.20
Requires: libpng-devel >= 1.2.44
Requires: openssl-devel >= 0.9.8
Requires: zlib-devel

%description devel
RRD is the Acronym for Round Robin Database. RRD is a system to store and
display time-series data (i.e. network bandwidth, machine-room temperature,
server load average). This package allow you to use directly this library.

If you are compiling a 32-bit program, no special compiler options are
needed.

If you are compiling a 64-bit program, you have to compile and link your
application with "xlc_r -q64" or "gcc -maix64".


%package perl
Summary: Perl RRDtool bindings
Group: Development/Languages
Requires: %{name} = %{version}
Requires: perl >= 5.8.8
Provides: %{name}-perl

%description perl
The Perl RRDtool bindings.


%package python
Summary: Python RRDtool bindings
Group: Development/Languages
Requires: %{name} = %{version}-%{release}
Requires: python >= 2.6.2
Obsoletes: python-%{name} < %{version}-%{release}
Provides: python-%{name} = %{version}-%{release}

%description python
The Python RRDtool bindings.


%package tcl
Summary: Tcl RRDtool bindings
Group: Development/Languages
BuildRequires: tcl-devel >= 8.5.8-2
Requires: tcl >= 8.5.8-2
Requires: %{name} = %{version}-%{release}
Obsoletes: tcl-%{name} < %{version}-%{release}
Provides: tcl-%{name} = %{version}-%{release}

%description tcl
The %{name}-tcl package includes RRDtool bindings for Tcl.


%prep
%setup -q
%patch0
mkdir ../32bit
mv * ../32bit
mv ../32bit .
mkdir 64bit
cd 32bit && tar cf - . | (cd ../64bit ; tar xpf -)


%build
export CC="xlc_r"

# we want "our" perl...
export PATH=/opt/freeware/bin:$PATH

cd 64bit
# first build the 64-bit version
export OBJECT_MODE=64
export PERL=%{_bindir}/perl_64bit
export PYTHON=%{_bindir}/python_64
export LDFLAGS="-L/opt/freeware/lib64 -L/opt/freeware/lib -blibpath:/opt/freeware/lib64:/opt/freeware/lib:/usr/lib:/lib -bmaxdata:0x80000000"
./configure \
    --prefix=%{_prefix} \
    --libdir=%{_libdir64} \
    --mandir=%{_mandir} \
    --enable-shared --disable-static \
    --enable-pthread \
    --enable-perl \
    --enable-python \
    --enable-tcl-site \
    --with-tcllib=%{_libdir64} \
    --disable-ruby
make %{?_smp_mflags}

cd ../32bit
# now build the 32-bit version
export OBJECT_MODE=32
export PERL=%{_bindir}/perl
export PYTHON=%{_bindir}/python
export LDFLAGS="-L/opt/freeware/lib -blibpath:/opt/freeware/lib:/usr/lib:/lib -bmaxdata:0x80000000"
./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --enable-shared --disable-static \
    --enable-pthread \
    --enable-perl \
    --enable-python \
    --enable-tcl-site \
    --with-tcllib=%{_libdir} \
    --disable-ruby
make %{?_smp_mflags}


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

cd 64bit
export OBJECT_MODE=64
make DESTDIR=${RPM_BUILD_ROOT} install

(
  cd ${RPM_BUILD_ROOT}%{_bindir}
  for f in * ; do
    mv -f ${f} ${f}_64
  done
)

cd ../32bit
export OBJECT_MODE=32
gmake DESTDIR=${RPM_BUILD_ROOT} install

/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :

(
  cd ${RPM_BUILD_ROOT}%{_libdir64}
  for f in *.a ; do
    /usr/bin/ar -X64 -x ${f}
  done

  cd ${RPM_BUILD_ROOT}%{_libdir}
  for f in *.a ; do
    /usr/bin/ar -X32 -x ${f}
  done
)

# add the 64-bit shared objects to the shared library containing already the
# 32-bit shared objects
/usr/bin/ar -X64 -q ${RPM_BUILD_ROOT}%{_libdir}/librrd.a ${RPM_BUILD_ROOT}%{_libdir64}/librrd.so.2
/usr/bin/ar -X64 -q ${RPM_BUILD_ROOT}%{_libdir}/librrd_th.a ${RPM_BUILD_ROOT}%{_libdir64}/librrd_th.so.2

# We only want .txt and .html files for the main documentation
mkdir -p rpm-doc/docs/
/opt/freeware/bin/cp -ap doc/*.txt doc/*.html rpm-doc/docs/

rm -f examples/Makefile* examples/*.in

# clean up buildroot
rm -rf ${RPM_BUILD_ROOT}%{_libdir}/perl/5.8.*/ppc-aix*/*/*/.packlist

(
  cd ${RPM_BUILD_ROOT}
  for dir in bin include lib lib64
  do
    mkdir -p usr/${dir}
    cd usr/${dir}
    ln -sf ../..%{_prefix}/${dir}/* .
    cd -
  done
)


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

 
%files
%defattr(-,root,system,-)
%doc 32bit/CHANGES 32bit/CONTRIBUTORS 32bit/COPYING 32bit/COPYRIGHT
%doc 32bit/NEWS 32bit/README 32bit/THREADS 32bit/TODO
%doc 32bit/rpm-doc/docs/
%{_bindir}/rrdcgi*
%{_bindir}/rrdtool*
%{_bindir}/rrdupdate*
%{_libdir}/*.a
%{_libdir}/*.so*
%{_libdir64}/*.so*
%{_mandir}/man1/[b,c]*
%{_mandir}/man1/rpn*
%{_mandir}/man1/rrd-beginners.1
%{_mandir}/man1/rrd[a-b,d-i,r-x]*
%{_mandir}/man1/rrdcgi.1
%{_mandir}/man1/rrdcreate.1
%{_mandir}/man1/rrdlast*.1
%{_datadir}/%{name}/fonts/
/usr/bin/rrdcgi*
/usr/bin/rrdtool*
/usr/bin/rrdupdate*
/usr/lib/*.a
/usr/lib/*.so*
/usr/lib64/*.so*


%files devel
%defattr(-,root,system,-)
%{_includedir}/*
%{_libdir}/*.la
%{_libdir64}/*.la
/usr/include/*
/usr/lib/*.la
/usr/lib64/*.la


%files perl
%defattr(-,root,system,-)
%doc 32bit/examples/
%{_libdir}/perl/5.*/*
%{_mandir}/man3/RRD*.3
%{_datadir}/%{name}


%files python
%defattr(-,root,system,-)
%doc 32bit/bindings/python/AUTHORS 32bit/bindings/python/COPYING
%doc 32bit/bindings/python/README
%{python_sitearch}/*
%{python_sitearch64}/*


%files tcl
%defattr(-,root,system,-)
%doc 32bit/bindings/tcl/README
%{_libdir}/tclrrd*.so
%{_libdir64}/tclrrd*.so
%{_libdir}/%{name}/*.tcl
%{_libdir64}/%{name}/*.tcl


%changelog
* Fri Jul 01 2011 Michael Perzl <michael@perzl.org> - 1.2.30-3
- added tcl and python bindings
- renamed perl-rrdtool to rrdtool-perl

* Mon Jun 22 2009 Michael Perzl <michael@perzl.org> - 1.2.30-2
- fixed some spec file issues

* Mon Jan 19 2009 Michael Perzl <michael@perzl.org> - 1.2.30-1
- updated to version 1.2.30

* Fri Jan 16 2009 Michael Perzl <michael@perzl.org> - 1.2.29-1
- updated to version 1.2.29

* Mon Nov 24 2008 Michael Perzl <michael@perzl.org> - 1.2.28-1
- updated to version 1.2.28

* Fri Feb 22 2008 Michael Perzl <michael@perzl.org> - 1.2.27-1
- updated to version 1.2.27

* Fri Jan 11 2008 Michael Perzl <michael@perzl.org> - 1.2.26-2
- included both 32-bit and 64-bit shared objects

* Wed Nov 21 2007 Michael Perzl <michael at perzl dot org> - 1.2.26-1
- updated to version 1.2.26

* Wed Nov 15 2007 Michael Perzl <michael at perzl dot org> - 1.2.25-1
- updated to version 1.2.25

* Mon Nov 12 2007 Michael Perzl <michael at perzl dot org> - 1.2.23-2
- prevent rrdtool from core dumping when compiled with shared library

* Wed Jul 11 2007 Michael Perzl <michael at perzl dot org> - 1.2.23-1
- first version for AIX V5.1 and higher
